# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

#### Public Classes

* [`slurm`](#slurm): Manage SLURM

#### Private Classes

* `slurm::client`
* `slurm::common::config`
* `slurm::common::install`
* `slurm::common::install::apt`
* `slurm::common::install::rpm`
* `slurm::common::install::source`
* `slurm::common::munge`
* `slurm::common::setup`
* `slurm::common::user`
* `slurm::params`
* `slurm::resources`: Manage SLURM resources using Puppet types
* `slurm::slurmctld`
* `slurm::slurmctld::config`
* `slurm::slurmctld::service`
* `slurm::slurmd`
* `slurm::slurmd::config`
* `slurm::slurmd::service`
* `slurm::slurmdbd`
* `slurm::slurmdbd::config`
* `slurm::slurmdbd::db`
* `slurm::slurmdbd::service`
* `slurm::slurmrestd`
* `slurm::slurmrestd::service`

### Defined types

* [`slurm::down_node`](#slurmdown_node): Manage SLURM down node configuration
* [`slurm::gres`](#slurmgres): Manage SLURM GRES configuration
* [`slurm::job_container`](#slurmjob_container): Manage SLURM job_container.conf entry
* [`slurm::node`](#slurmnode): Manage SLURM node configuration
* [`slurm::nodeset`](#slurmnodeset): Manage SLURM nodeset configuration
* [`slurm::partition`](#slurmpartition): Manage a SLURM partition configuration
* [`slurm::spank`](#slurmspank): Manage SLURM SPANK plugin
* [`slurm::switch`](#slurmswitch): Add switch to topology.conf

### Data types

* [`Slurm::DownNodeState`](#slurmdownnodestate)
* [`Slurm::NodeState`](#slurmnodestate)
* [`Slurm::PartitionState`](#slurmpartitionstate)
* [`Slurm::PreemptMode`](#slurmpreemptmode)
* [`Slurm::SelectTypeParameters`](#slurmselecttypeparameters)

### Tasks

* [`reconfig`](#reconfig): Execute 'scontrol reconfig'

## Classes

### <a name="slurm"></a>`slurm`

Roles

#### Parameters

The following parameters are available in the `slurm` class:

* [`slurmd`](#slurmd)
* [`slurmctld`](#slurmctld)
* [`slurmdbd`](#slurmdbd)
* [`database`](#database)
* [`client`](#client)
* [`slurmrestd`](#slurmrestd)
* [`repo_baseurl`](#repo_baseurl)
* [`install_method`](#install_method)
* [`install_prefix`](#install_prefix)
* [`package_ensure`](#package_ensure)
* [`install_torque_wrapper`](#install_torque_wrapper)
* [`install_pam`](#install_pam)
* [`version`](#version)
* [`source_dependencies`](#source_dependencies)
* [`configure_flags`](#configure_flags)
* [`source_install_manage_alternatives`](#source_install_manage_alternatives)
* [`slurmd_service_ensure`](#slurmd_service_ensure)
* [`slurmd_service_enable`](#slurmd_service_enable)
* [`slurmd_service_limits`](#slurmd_service_limits)
* [`slurmd_options`](#slurmd_options)
* [`slurmctld_service_ensure`](#slurmctld_service_ensure)
* [`slurmctld_service_enable`](#slurmctld_service_enable)
* [`slurmctld_service_limits`](#slurmctld_service_limits)
* [`slurmctld_options`](#slurmctld_options)
* [`slurmdbd_service_ensure`](#slurmdbd_service_ensure)
* [`slurmdbd_service_enable`](#slurmdbd_service_enable)
* [`slurmdbd_service_limits`](#slurmdbd_service_limits)
* [`slurmdbd_options`](#slurmdbd_options)
* [`slurmctld_restart_on_failure`](#slurmctld_restart_on_failure)
* [`slurmdbd_restart_on_failure`](#slurmdbd_restart_on_failure)
* [`reload_services`](#reload_services)
* [`restart_services`](#restart_services)
* [`slurmctld_conn_validator_timeout`](#slurmctld_conn_validator_timeout)
* [`manage_slurm_user`](#manage_slurm_user)
* [`slurm_user_group`](#slurm_user_group)
* [`slurm_group_gid`](#slurm_group_gid)
* [`slurm_user`](#slurm_user)
* [`slurm_user_uid`](#slurm_user_uid)
* [`slurm_user_comment`](#slurm_user_comment)
* [`slurm_user_home`](#slurm_user_home)
* [`slurm_user_managehome`](#slurm_user_managehome)
* [`slurm_user_shell`](#slurm_user_shell)
* [`slurmd_user`](#slurmd_user)
* [`slurmd_user_group`](#slurmd_user_group)
* [`manage_munge`](#manage_munge)
* [`munge_key_source`](#munge_key_source)
* [`munge_key_content`](#munge_key_content)
* [`manage_slurm_conf`](#manage_slurm_conf)
* [`manage_scripts`](#manage_scripts)
* [`manage_firewall`](#manage_firewall)
* [`use_syslog`](#use_syslog)
* [`manage_logrotate`](#manage_logrotate)
* [`logrotate_syslog_pid_path`](#logrotate_syslog_pid_path)
* [`manage_rsyslog`](#manage_rsyslog)
* [`manage_database`](#manage_database)
* [`export_database`](#export_database)
* [`export_database_tag`](#export_database_tag)
* [`cli_filter_lua_source`](#cli_filter_lua_source)
* [`cli_filter_lua_content`](#cli_filter_lua_content)
* [`state_dir_nfs_device`](#state_dir_nfs_device)
* [`state_dir_nfs_options`](#state_dir_nfs_options)
* [`job_submit_lua_source`](#job_submit_lua_source)
* [`job_submit_lua_content`](#job_submit_lua_content)
* [`cluster_name`](#cluster_name)
* [`slurmctld_host`](#slurmctld_host)
* [`slurmdbd_host`](#slurmdbd_host)
* [`conf_dir`](#conf_dir)
* [`log_dir`](#log_dir)
* [`env_dir`](#env_dir)
* [`spank_plugins`](#spank_plugins)
* [`enable_configless`](#enable_configless)
* [`configless`](#configless)
* [`conf_server`](#conf_server)
* [`slurm_conf_override`](#slurm_conf_override)
* [`slurm_conf_template`](#slurm_conf_template)
* [`slurm_conf_source`](#slurm_conf_source)
* [`partition_template`](#partition_template)
* [`partition_source`](#partition_source)
* [`node_template`](#node_template)
* [`node_source`](#node_source)
* [`switch_template`](#switch_template)
* [`topology_source`](#topology_source)
* [`gres_template`](#gres_template)
* [`gres_source`](#gres_source)
* [`partitions`](#partitions)
* [`nodes`](#nodes)
* [`nodesets`](#nodesets)
* [`switches`](#switches)
* [`greses`](#greses)
* [`job_containers`](#job_containers)
* [`slurmd_log_file`](#slurmd_log_file)
* [`slurmd_spool_dir`](#slurmd_spool_dir)
* [`slurmctld_log_file`](#slurmctld_log_file)
* [`state_save_location`](#state_save_location)
* [`slurmdbd_archive_dir`](#slurmdbd_archive_dir)
* [`slurmdbd_log_file`](#slurmdbd_log_file)
* [`slurmdbd_storage_host`](#slurmdbd_storage_host)
* [`slurmdbd_storage_loc`](#slurmdbd_storage_loc)
* [`slurmdbd_storage_pass`](#slurmdbd_storage_pass)
* [`slurmdbd_storage_port`](#slurmdbd_storage_port)
* [`slurmdbd_storage_type`](#slurmdbd_storage_type)
* [`slurmdbd_storage_user`](#slurmdbd_storage_user)
* [`slurmdbd_conf_override`](#slurmdbd_conf_override)
* [`slurmdbd_archive_dir_nfs_device`](#slurmdbd_archive_dir_nfs_device)
* [`slurmdbd_archive_dir_nfs_options`](#slurmdbd_archive_dir_nfs_options)
* [`use_nhc`](#use_nhc)
* [`include_nhc`](#include_nhc)
* [`health_check_program`](#health_check_program)
* [`health_check_program_source`](#health_check_program_source)
* [`manage_epilog`](#manage_epilog)
* [`epilog`](#epilog)
* [`epilog_source`](#epilog_source)
* [`epilog_sourceselect`](#epilog_sourceselect)
* [`manage_prolog`](#manage_prolog)
* [`prolog`](#prolog)
* [`prolog_source`](#prolog_source)
* [`prolog_sourceselect`](#prolog_sourceselect)
* [`manage_task_epilog`](#manage_task_epilog)
* [`task_epilog`](#task_epilog)
* [`task_epilog_source`](#task_epilog_source)
* [`manage_task_prolog`](#manage_task_prolog)
* [`task_prolog`](#task_prolog)
* [`task_prolog_source`](#task_prolog_source)
* [`auth_alt_types`](#auth_alt_types)
* [`jwt_key_content`](#jwt_key_content)
* [`jwt_key_source`](#jwt_key_source)
* [`slurmrestd_listen_address`](#slurmrestd_listen_address)
* [`slurmrestd_disable_token_creation`](#slurmrestd_disable_token_creation)
* [`slurmrestd_user`](#slurmrestd_user)
* [`slurmrestd_user_group`](#slurmrestd_user_group)
* [`slurmrestd_service_ensure`](#slurmrestd_service_ensure)
* [`slurmrestd_service_enable`](#slurmrestd_service_enable)
* [`slurmrestd_service_limits`](#slurmrestd_service_limits)
* [`slurmrestd_options`](#slurmrestd_options)
* [`slurmrestd_restart_on_failure`](#slurmrestd_restart_on_failure)
* [`cgroup_conf_template`](#cgroup_conf_template)
* [`cgroup_conf_source`](#cgroup_conf_source)
* [`cgroup_automount`](#cgroup_automount)
* [`cgroup_mountpoint`](#cgroup_mountpoint)
* [`cgroup_plugin`](#cgroup_plugin)
* [`cgroup_allowed_kmem_space`](#cgroup_allowed_kmem_space)
* [`cgroup_allowed_ram_space`](#cgroup_allowed_ram_space)
* [`cgroup_allowed_swap_space`](#cgroup_allowed_swap_space)
* [`cgroup_constrain_cores`](#cgroup_constrain_cores)
* [`cgroup_constrain_devices`](#cgroup_constrain_devices)
* [`cgroup_constrain_kmem_space`](#cgroup_constrain_kmem_space)
* [`cgroup_constrain_ram_space`](#cgroup_constrain_ram_space)
* [`cgroup_constrain_swap_space`](#cgroup_constrain_swap_space)
* [`cgroup_max_ram_percent`](#cgroup_max_ram_percent)
* [`cgroup_max_swap_percent`](#cgroup_max_swap_percent)
* [`cgroup_max_kmem_percent`](#cgroup_max_kmem_percent)
* [`cgroup_memory_swappiness`](#cgroup_memory_swappiness)
* [`cgroup_min_kmem_space`](#cgroup_min_kmem_space)
* [`cgroup_min_ram_space`](#cgroup_min_ram_space)
* [`slurm_sh_template`](#slurm_sh_template)
* [`slurm_csh_template`](#slurm_csh_template)
* [`profile_d_env_vars`](#profile_d_env_vars)
* [`slurmd_port`](#slurmd_port)
* [`slurmctld_port`](#slurmctld_port)
* [`slurmdbd_port`](#slurmdbd_port)
* [`slurmrestd_port`](#slurmrestd_port)
* [`tuning_net_core_somaxconn`](#tuning_net_core_somaxconn)
* [`include_resources`](#include_resources)
* [`clusters`](#clusters)
* [`qoses`](#qoses)
* [`reservations`](#reservations)
* [`accounts`](#accounts)
* [`users`](#users)
* [`licenses`](#licenses)
* [`purge_qos`](#purge_qos)
* [`slurmdbd_conn_validator_timeout`](#slurmdbd_conn_validator_timeout)

##### <a name="slurmd"></a>`slurmd`

Data type: `Boolean`



Default value: ``false``

##### <a name="slurmctld"></a>`slurmctld`

Data type: `Boolean`



Default value: ``false``

##### <a name="slurmdbd"></a>`slurmdbd`

Data type: `Boolean`



Default value: ``false``

##### <a name="database"></a>`database`

Data type: `Boolean`



Default value: ``false``

##### <a name="client"></a>`client`

Data type: `Boolean`



Default value: ``true``

##### <a name="slurmrestd"></a>`slurmrestd`

Data type: `Boolean`



Default value: ``false``

##### <a name="repo_baseurl"></a>`repo_baseurl`

Data type: `Optional[Variant[Stdlib::HTTPSUrl, Stdlib::HTTPUrl, Pattern[/^file:\/\//]]]`



Default value: ``undef``

##### <a name="install_method"></a>`install_method`

Data type: `Optional[Enum['package','source']]`



Default value: ``undef``

##### <a name="install_prefix"></a>`install_prefix`

Data type: `Stdlib::Absolutepath`



Default value: `'/usr'`

##### <a name="package_ensure"></a>`package_ensure`

Data type: `String`



Default value: `'present'`

##### <a name="install_torque_wrapper"></a>`install_torque_wrapper`

Data type: `Boolean`



Default value: ``false``

##### <a name="install_pam"></a>`install_pam`

Data type: `Boolean`



Default value: ``true``

##### <a name="version"></a>`version`

Data type: `String`



Default value: `'21.08.4'`

##### <a name="source_dependencies"></a>`source_dependencies`

Data type: `Array`



Default value: `[]`

##### <a name="configure_flags"></a>`configure_flags`

Data type: `Array`



Default value: `[]`

##### <a name="source_install_manage_alternatives"></a>`source_install_manage_alternatives`

Data type: `Boolean`



Default value: ``true``

##### <a name="slurmd_service_ensure"></a>`slurmd_service_ensure`

Data type: `Enum['running','stopped']`



Default value: `'running'`

##### <a name="slurmd_service_enable"></a>`slurmd_service_enable`

Data type: `Boolean`



Default value: ``true``

##### <a name="slurmd_service_limits"></a>`slurmd_service_limits`

Data type: `Hash`



Default value: `{}`

##### <a name="slurmd_options"></a>`slurmd_options`

Data type: `String`



Default value: `''`

##### <a name="slurmctld_service_ensure"></a>`slurmctld_service_ensure`

Data type: `Enum['running','stopped']`



Default value: `'running'`

##### <a name="slurmctld_service_enable"></a>`slurmctld_service_enable`

Data type: `Boolean`



Default value: ``true``

##### <a name="slurmctld_service_limits"></a>`slurmctld_service_limits`

Data type: `Hash`



Default value: `{}`

##### <a name="slurmctld_options"></a>`slurmctld_options`

Data type: `String`



Default value: `''`

##### <a name="slurmdbd_service_ensure"></a>`slurmdbd_service_ensure`

Data type: `Enum['running','stopped']`



Default value: `'running'`

##### <a name="slurmdbd_service_enable"></a>`slurmdbd_service_enable`

Data type: `Boolean`



Default value: ``true``

##### <a name="slurmdbd_service_limits"></a>`slurmdbd_service_limits`

Data type: `Hash`



Default value: `{}`

##### <a name="slurmdbd_options"></a>`slurmdbd_options`

Data type: `String`



Default value: `''`

##### <a name="slurmctld_restart_on_failure"></a>`slurmctld_restart_on_failure`

Data type: `Boolean`



Default value: ``true``

##### <a name="slurmdbd_restart_on_failure"></a>`slurmdbd_restart_on_failure`

Data type: `Boolean`



Default value: ``true``

##### <a name="reload_services"></a>`reload_services`

Data type: `Boolean`



Default value: ``false``

##### <a name="restart_services"></a>`restart_services`

Data type: `Boolean`



Default value: ``true``

##### <a name="slurmctld_conn_validator_timeout"></a>`slurmctld_conn_validator_timeout`

Data type: `Integer`



Default value: `60`

##### <a name="manage_slurm_user"></a>`manage_slurm_user`

Data type: `Any`



Default value: ``true``

##### <a name="slurm_user_group"></a>`slurm_user_group`

Data type: `Any`



Default value: `'slurm'`

##### <a name="slurm_group_gid"></a>`slurm_group_gid`

Data type: `Any`



Default value: ``undef``

##### <a name="slurm_user"></a>`slurm_user`

Data type: `Any`



Default value: `'slurm'`

##### <a name="slurm_user_uid"></a>`slurm_user_uid`

Data type: `Any`



Default value: ``undef``

##### <a name="slurm_user_comment"></a>`slurm_user_comment`

Data type: `Any`



Default value: `'SLURM User'`

##### <a name="slurm_user_home"></a>`slurm_user_home`

Data type: `Any`



Default value: `'/var/lib/slurm'`

##### <a name="slurm_user_managehome"></a>`slurm_user_managehome`

Data type: `Any`



Default value: ``true``

##### <a name="slurm_user_shell"></a>`slurm_user_shell`

Data type: `Any`



Default value: `'/sbin/nologin'`

##### <a name="slurmd_user"></a>`slurmd_user`

Data type: `Any`



Default value: `'root'`

##### <a name="slurmd_user_group"></a>`slurmd_user_group`

Data type: `Any`



Default value: `'root'`

##### <a name="manage_munge"></a>`manage_munge`

Data type: `Boolean`



Default value: ``false``

##### <a name="munge_key_source"></a>`munge_key_source`

Data type: `Optional[String]`



Default value: ``undef``

##### <a name="munge_key_content"></a>`munge_key_content`

Data type: `Optional[String]`



Default value: ``undef``

##### <a name="manage_slurm_conf"></a>`manage_slurm_conf`

Data type: `Any`



Default value: ``true``

##### <a name="manage_scripts"></a>`manage_scripts`

Data type: `Any`



Default value: ``true``

##### <a name="manage_firewall"></a>`manage_firewall`

Data type: `Any`



Default value: ``true``

##### <a name="use_syslog"></a>`use_syslog`

Data type: `Any`



Default value: ``false``

##### <a name="manage_logrotate"></a>`manage_logrotate`

Data type: `Any`



Default value: ``true``

##### <a name="logrotate_syslog_pid_path"></a>`logrotate_syslog_pid_path`

Data type: `Any`



Default value: `'/var/run/syslogd.pid'`

##### <a name="manage_rsyslog"></a>`manage_rsyslog`

Data type: `Any`



Default value: ``true``

##### <a name="manage_database"></a>`manage_database`

Data type: `Any`



Default value: ``true``

##### <a name="export_database"></a>`export_database`

Data type: `Any`



Default value: ``false``

##### <a name="export_database_tag"></a>`export_database_tag`

Data type: `Any`



Default value: `$facts['domain']`

##### <a name="cli_filter_lua_source"></a>`cli_filter_lua_source`

Data type: `Any`



Default value: ``undef``

##### <a name="cli_filter_lua_content"></a>`cli_filter_lua_content`

Data type: `Any`



Default value: ``undef``

##### <a name="state_dir_nfs_device"></a>`state_dir_nfs_device`

Data type: `Any`



Default value: ``undef``

##### <a name="state_dir_nfs_options"></a>`state_dir_nfs_options`

Data type: `Any`



Default value: `'rw,sync,noexec,nolock,auto'`

##### <a name="job_submit_lua_source"></a>`job_submit_lua_source`

Data type: `Any`



Default value: ``undef``

##### <a name="job_submit_lua_content"></a>`job_submit_lua_content`

Data type: `Any`



Default value: ``undef``

##### <a name="cluster_name"></a>`cluster_name`

Data type: `Any`



Default value: `'linux'`

##### <a name="slurmctld_host"></a>`slurmctld_host`

Data type: `Variant[Array, String]`



Default value: `'slurm'`

##### <a name="slurmdbd_host"></a>`slurmdbd_host`

Data type: `Any`



Default value: `'slurmdbd'`

##### <a name="conf_dir"></a>`conf_dir`

Data type: `Stdlib::Absolutepath`



Default value: `'/etc/slurm'`

##### <a name="log_dir"></a>`log_dir`

Data type: `Stdlib::Absolutepath`



Default value: `'/var/log/slurm'`

##### <a name="env_dir"></a>`env_dir`

Data type: `Stdlib::Absolutepath`



Default value: `'/etc/sysconfig'`

##### <a name="spank_plugins"></a>`spank_plugins`

Data type: `Hash`



Default value: `{}`

##### <a name="enable_configless"></a>`enable_configless`

Data type: `Boolean`



Default value: ``false``

##### <a name="configless"></a>`configless`

Data type: `Boolean`



Default value: ``false``

##### <a name="conf_server"></a>`conf_server`

Data type: `Optional[String]`



Default value: ``undef``

##### <a name="slurm_conf_override"></a>`slurm_conf_override`

Data type: `Any`



Default value: `{}`

##### <a name="slurm_conf_template"></a>`slurm_conf_template`

Data type: `Any`



Default value: `'slurm/slurm.conf/slurm.conf.erb'`

##### <a name="slurm_conf_source"></a>`slurm_conf_source`

Data type: `Any`



Default value: ``undef``

##### <a name="partition_template"></a>`partition_template`

Data type: `Any`



Default value: `'slurm/slurm.conf/conf_values.erb'`

##### <a name="partition_source"></a>`partition_source`

Data type: `Any`



Default value: ``undef``

##### <a name="node_template"></a>`node_template`

Data type: `Any`



Default value: `'slurm/slurm.conf/conf_values.erb'`

##### <a name="node_source"></a>`node_source`

Data type: `Any`



Default value: ``undef``

##### <a name="switch_template"></a>`switch_template`

Data type: `Any`



Default value: `'slurm/slurm.conf/conf_values.erb'`

##### <a name="topology_source"></a>`topology_source`

Data type: `Any`



Default value: ``undef``

##### <a name="gres_template"></a>`gres_template`

Data type: `Any`



Default value: `'slurm/slurm.conf/conf_values.erb'`

##### <a name="gres_source"></a>`gres_source`

Data type: `Any`



Default value: ``undef``

##### <a name="partitions"></a>`partitions`

Data type: `Any`



Default value: `{}`

##### <a name="nodes"></a>`nodes`

Data type: `Any`



Default value: `{}`

##### <a name="nodesets"></a>`nodesets`

Data type: `Any`



Default value: `{}`

##### <a name="switches"></a>`switches`

Data type: `Any`



Default value: `{}`

##### <a name="greses"></a>`greses`

Data type: `Any`



Default value: `{}`

##### <a name="job_containers"></a>`job_containers`

Data type: `Any`



Default value: `{}`

##### <a name="slurmd_log_file"></a>`slurmd_log_file`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: ``undef``

##### <a name="slurmd_spool_dir"></a>`slurmd_spool_dir`

Data type: `Any`



Default value: `'/var/spool/slurmd'`

##### <a name="slurmctld_log_file"></a>`slurmctld_log_file`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: ``undef``

##### <a name="state_save_location"></a>`state_save_location`

Data type: `Any`



Default value: `'/var/spool/slurmctld.state'`

##### <a name="slurmdbd_archive_dir"></a>`slurmdbd_archive_dir`

Data type: `Stdlib::Absolutepath`



Default value: `'/var/lib/slurmdbd.archive'`

##### <a name="slurmdbd_log_file"></a>`slurmdbd_log_file`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: ``undef``

##### <a name="slurmdbd_storage_host"></a>`slurmdbd_storage_host`

Data type: `Any`



Default value: `'localhost'`

##### <a name="slurmdbd_storage_loc"></a>`slurmdbd_storage_loc`

Data type: `Any`



Default value: `'slurm_acct_db'`

##### <a name="slurmdbd_storage_pass"></a>`slurmdbd_storage_pass`

Data type: `Any`



Default value: `'slurmdbd'`

##### <a name="slurmdbd_storage_port"></a>`slurmdbd_storage_port`

Data type: `Any`



Default value: `'3306'`

##### <a name="slurmdbd_storage_type"></a>`slurmdbd_storage_type`

Data type: `Any`



Default value: `'accounting_storage/mysql'`

##### <a name="slurmdbd_storage_user"></a>`slurmdbd_storage_user`

Data type: `Any`



Default value: `'slurmdbd'`

##### <a name="slurmdbd_conf_override"></a>`slurmdbd_conf_override`

Data type: `Any`



Default value: `{}`

##### <a name="slurmdbd_archive_dir_nfs_device"></a>`slurmdbd_archive_dir_nfs_device`

Data type: `Any`



Default value: ``undef``

##### <a name="slurmdbd_archive_dir_nfs_options"></a>`slurmdbd_archive_dir_nfs_options`

Data type: `Any`



Default value: `'rw,sync,noexec,nolock,auto'`

##### <a name="use_nhc"></a>`use_nhc`

Data type: `Any`



Default value: ``false``

##### <a name="include_nhc"></a>`include_nhc`

Data type: `Any`



Default value: ``false``

##### <a name="health_check_program"></a>`health_check_program`

Data type: `Any`



Default value: ``undef``

##### <a name="health_check_program_source"></a>`health_check_program_source`

Data type: `Any`



Default value: ``undef``

##### <a name="manage_epilog"></a>`manage_epilog`

Data type: `Any`



Default value: ``true``

##### <a name="epilog"></a>`epilog`

Data type: `Any`



Default value: ``undef``

##### <a name="epilog_source"></a>`epilog_source`

Data type: `Any`



Default value: ``undef``

##### <a name="epilog_sourceselect"></a>`epilog_sourceselect`

Data type: `Any`



Default value: ``undef``

##### <a name="manage_prolog"></a>`manage_prolog`

Data type: `Any`



Default value: ``true``

##### <a name="prolog"></a>`prolog`

Data type: `Any`



Default value: ``undef``

##### <a name="prolog_source"></a>`prolog_source`

Data type: `Any`



Default value: ``undef``

##### <a name="prolog_sourceselect"></a>`prolog_sourceselect`

Data type: `Any`



Default value: ``undef``

##### <a name="manage_task_epilog"></a>`manage_task_epilog`

Data type: `Any`



Default value: ``true``

##### <a name="task_epilog"></a>`task_epilog`

Data type: `Any`



Default value: ``undef``

##### <a name="task_epilog_source"></a>`task_epilog_source`

Data type: `Any`



Default value: ``undef``

##### <a name="manage_task_prolog"></a>`manage_task_prolog`

Data type: `Any`



Default value: ``true``

##### <a name="task_prolog"></a>`task_prolog`

Data type: `Any`



Default value: ``undef``

##### <a name="task_prolog_source"></a>`task_prolog_source`

Data type: `Any`



Default value: ``undef``

##### <a name="auth_alt_types"></a>`auth_alt_types`

Data type: `Array`



Default value: `[]`

##### <a name="jwt_key_content"></a>`jwt_key_content`

Data type: `Optional[String]`



Default value: ``undef``

##### <a name="jwt_key_source"></a>`jwt_key_source`

Data type: `Optional[String]`



Default value: ``undef``

##### <a name="slurmrestd_listen_address"></a>`slurmrestd_listen_address`

Data type: `String`



Default value: `$facts['networking']['ip']`

##### <a name="slurmrestd_disable_token_creation"></a>`slurmrestd_disable_token_creation`

Data type: `Boolean`



Default value: ``false``

##### <a name="slurmrestd_user"></a>`slurmrestd_user`

Data type: `String`



Default value: `'nobody'`

##### <a name="slurmrestd_user_group"></a>`slurmrestd_user_group`

Data type: `String`



Default value: `'nobody'`

##### <a name="slurmrestd_service_ensure"></a>`slurmrestd_service_ensure`

Data type: `Enum['running','stopped']`



Default value: `'running'`

##### <a name="slurmrestd_service_enable"></a>`slurmrestd_service_enable`

Data type: `Boolean`



Default value: ``true``

##### <a name="slurmrestd_service_limits"></a>`slurmrestd_service_limits`

Data type: `Hash`



Default value: `{}`

##### <a name="slurmrestd_options"></a>`slurmrestd_options`

Data type: `String`



Default value: `''`

##### <a name="slurmrestd_restart_on_failure"></a>`slurmrestd_restart_on_failure`

Data type: `Boolean`



Default value: ``true``

##### <a name="cgroup_conf_template"></a>`cgroup_conf_template`

Data type: `String`



Default value: `'slurm/cgroup/cgroup.conf.erb'`

##### <a name="cgroup_conf_source"></a>`cgroup_conf_source`

Data type: `Optional[String]`



Default value: ``undef``

##### <a name="cgroup_automount"></a>`cgroup_automount`

Data type: `Boolean`



Default value: ``true``

##### <a name="cgroup_mountpoint"></a>`cgroup_mountpoint`

Data type: `Stdlib::Absolutepath`



Default value: `'/sys/fs/cgroup'`

##### <a name="cgroup_plugin"></a>`cgroup_plugin`

Data type: `Optional[String]`



Default value: ``undef``

##### <a name="cgroup_allowed_kmem_space"></a>`cgroup_allowed_kmem_space`

Data type: `Optional[Integer]`



Default value: ``undef``

##### <a name="cgroup_allowed_ram_space"></a>`cgroup_allowed_ram_space`

Data type: `Integer`



Default value: `100`

##### <a name="cgroup_allowed_swap_space"></a>`cgroup_allowed_swap_space`

Data type: `Integer`



Default value: `0`

##### <a name="cgroup_constrain_cores"></a>`cgroup_constrain_cores`

Data type: `Boolean`



Default value: ``false``

##### <a name="cgroup_constrain_devices"></a>`cgroup_constrain_devices`

Data type: `Boolean`



Default value: ``false``

##### <a name="cgroup_constrain_kmem_space"></a>`cgroup_constrain_kmem_space`

Data type: `Boolean`



Default value: ``false``

##### <a name="cgroup_constrain_ram_space"></a>`cgroup_constrain_ram_space`

Data type: `Boolean`



Default value: ``false``

##### <a name="cgroup_constrain_swap_space"></a>`cgroup_constrain_swap_space`

Data type: `Boolean`



Default value: ``false``

##### <a name="cgroup_max_ram_percent"></a>`cgroup_max_ram_percent`

Data type: `Integer`



Default value: `100`

##### <a name="cgroup_max_swap_percent"></a>`cgroup_max_swap_percent`

Data type: `Integer`



Default value: `100`

##### <a name="cgroup_max_kmem_percent"></a>`cgroup_max_kmem_percent`

Data type: `Integer`



Default value: `100`

##### <a name="cgroup_memory_swappiness"></a>`cgroup_memory_swappiness`

Data type: `Optional[Integer[0,100]]`



Default value: ``undef``

##### <a name="cgroup_min_kmem_space"></a>`cgroup_min_kmem_space`

Data type: `Integer`



Default value: `30`

##### <a name="cgroup_min_ram_space"></a>`cgroup_min_ram_space`

Data type: `Integer`



Default value: `30`

##### <a name="slurm_sh_template"></a>`slurm_sh_template`

Data type: `Any`



Default value: `'slurm/profile.d/slurm.sh.erb'`

##### <a name="slurm_csh_template"></a>`slurm_csh_template`

Data type: `Any`



Default value: `'slurm/profile.d/slurm.csh.erb'`

##### <a name="profile_d_env_vars"></a>`profile_d_env_vars`

Data type: `Hash`



Default value: `{}`

##### <a name="slurmd_port"></a>`slurmd_port`

Data type: `Stdlib::Port`



Default value: `6818`

##### <a name="slurmctld_port"></a>`slurmctld_port`

Data type: `Stdlib::Port`



Default value: `6817`

##### <a name="slurmdbd_port"></a>`slurmdbd_port`

Data type: `Stdlib::Port`



Default value: `6819`

##### <a name="slurmrestd_port"></a>`slurmrestd_port`

Data type: `Stdlib::Port`



Default value: `6820`

##### <a name="tuning_net_core_somaxconn"></a>`tuning_net_core_somaxconn`

Data type: `Variant[Boolean, Integer]`



Default value: `1024`

##### <a name="include_resources"></a>`include_resources`

Data type: `Boolean`



Default value: ``false``

##### <a name="clusters"></a>`clusters`

Data type: `Hash`



Default value: `{}`

##### <a name="qoses"></a>`qoses`

Data type: `Hash`



Default value: `{}`

##### <a name="reservations"></a>`reservations`

Data type: `Hash`



Default value: `{}`

##### <a name="accounts"></a>`accounts`

Data type: `Hash`



Default value: `{}`

##### <a name="users"></a>`users`

Data type: `Hash`



Default value: `{}`

##### <a name="licenses"></a>`licenses`

Data type: `Hash`



Default value: `{}`

##### <a name="purge_qos"></a>`purge_qos`

Data type: `Boolean`



Default value: ``false``

##### <a name="slurmdbd_conn_validator_timeout"></a>`slurmdbd_conn_validator_timeout`

Data type: `Integer`



Default value: `30`

## Defined types

### <a name="slurmdown_node"></a>`slurm::down_node`

Manage SLURM down node configuration

#### Parameters

The following parameters are available in the `slurm::down_node` defined type:

* [`down_nodes`](#down_nodes)
* [`reason`](#reason)
* [`state`](#state)
* [`order`](#order)

##### <a name="down_nodes"></a>`down_nodes`

Data type: `String`



Default value: `$name`

##### <a name="reason"></a>`reason`

Data type: `Optional[String]`



Default value: ``undef``

##### <a name="state"></a>`state`

Data type: `Slurm::DownNodeState`



Default value: `'UNKNOWN'`

##### <a name="order"></a>`order`

Data type: `Any`



Default value: `'75'`

### <a name="slurmgres"></a>`slurm::gres`

Manage SLURM GRES configuration

#### Examples

##### Add static GPU GRES

```puppet
slurm::gres { 'gpu':
  type  => 'v100',
  file  => '/dev/nvidia0',
  cores => '0,1',
}
```

##### Add nvml AutoDetect gres

```puppet
slurm::gres { 'nvml':
  auto_detect => 'nvml',
}
```

#### Parameters

The following parameters are available in the `slurm::gres` defined type:

* [`gres_name`](#gres_name)
* [`type`](#type)
* [`node_name`](#node_name)
* [`auto_detect`](#auto_detect)
* [`count`](#count)
* [`cores`](#cores)
* [`file`](#file)
* [`flags`](#flags)
* [`links`](#links)
* [`switch_name`](#switch_name)
* [`switches`](#switches)
* [`link_speed`](#link_speed)
* [`order`](#order)

##### <a name="gres_name"></a>`gres_name`

Data type: `Any`



Default value: `$name`

##### <a name="type"></a>`type`

Data type: `Any`



Default value: ``undef``

##### <a name="node_name"></a>`node_name`

Data type: `Any`



Default value: ``undef``

##### <a name="auto_detect"></a>`auto_detect`

Data type: `Optional[Enum['nvml']]`



Default value: ``undef``

##### <a name="count"></a>`count`

Data type: `Any`



Default value: ``undef``

##### <a name="cores"></a>`cores`

Data type: `Any`



Default value: ``undef``

##### <a name="file"></a>`file`

Data type: `Any`



Default value: ``undef``

##### <a name="flags"></a>`flags`

Data type: `Optional[Enum['CountOnly']]`



Default value: ``undef``

##### <a name="links"></a>`links`

Data type: `Any`



Default value: ``undef``

##### <a name="switch_name"></a>`switch_name`

Data type: `Any`



Default value: `$name`

##### <a name="switches"></a>`switches`

Data type: `Any`



Default value: ``undef``

##### <a name="link_speed"></a>`link_speed`

Data type: `Any`



Default value: ``undef``

##### <a name="order"></a>`order`

Data type: `Any`



Default value: `'50'`

### <a name="slurmjob_container"></a>`slurm::job_container`

Manage SLURM job_container.conf entry

#### Parameters

The following parameters are available in the `slurm::job_container` defined type:

* [`base_path`](#base_path)
* [`auto_base_path`](#auto_base_path)
* [`init_script`](#init_script)
* [`node_name`](#node_name)
* [`order`](#order)

##### <a name="base_path"></a>`base_path`

Data type: `Stdlib::Absolutepath`

job_container.conf BasePath

##### <a name="auto_base_path"></a>`auto_base_path`

Data type: `Boolean`

job_container.conf AutoBasePath

Default value: ``false``

##### <a name="init_script"></a>`init_script`

Data type: `Optional[Stdlib::Absolutepath]`

job_container.conf InitScript

Default value: ``undef``

##### <a name="node_name"></a>`node_name`

Data type: `Optional[String]`

job_container.conf NodeName

Default value: ``undef``

##### <a name="order"></a>`order`

Data type: `Any`

Order in job_container.conf

Default value: `'50'`

### <a name="slurmnode"></a>`slurm::node`

Manage SLURM node configuration

#### Parameters

The following parameters are available in the `slurm::node` defined type:

* [`node_name`](#node_name)
* [`node_hostname`](#node_hostname)
* [`node_addr`](#node_addr)
* [`bcast_addr`](#bcast_addr)
* [`boards`](#boards)
* [`core_spec_count`](#core_spec_count)
* [`cores_per_socket`](#cores_per_socket)
* [`cpu_bind`](#cpu_bind)
* [`cpus`](#cpus)
* [`cpu_spec_list`](#cpu_spec_list)
* [`features`](#features)
* [`gres`](#gres)
* [`mem_spec_limit`](#mem_spec_limit)
* [`port`](#port)
* [`real_memory`](#real_memory)
* [`reason`](#reason)
* [`sockets`](#sockets)
* [`sockets_per_board`](#sockets_per_board)
* [`state`](#state)
* [`threads_per_core`](#threads_per_core)
* [`tmp_disk`](#tmp_disk)
* [`tres_weights`](#tres_weights)
* [`weight`](#weight)
* [`order`](#order)

##### <a name="node_name"></a>`node_name`

Data type: `Any`



Default value: `$name`

##### <a name="node_hostname"></a>`node_hostname`

Data type: `Any`



Default value: ``undef``

##### <a name="node_addr"></a>`node_addr`

Data type: `Any`



Default value: ``undef``

##### <a name="bcast_addr"></a>`bcast_addr`

Data type: `Any`



Default value: ``undef``

##### <a name="boards"></a>`boards`

Data type: `Any`



Default value: ``undef``

##### <a name="core_spec_count"></a>`core_spec_count`

Data type: `Any`



Default value: ``undef``

##### <a name="cores_per_socket"></a>`cores_per_socket`

Data type: `Any`



Default value: ``undef``

##### <a name="cpu_bind"></a>`cpu_bind`

Data type: `Any`



Default value: ``undef``

##### <a name="cpus"></a>`cpus`

Data type: `Any`



Default value: ``undef``

##### <a name="cpu_spec_list"></a>`cpu_spec_list`

Data type: `Any`



Default value: ``undef``

##### <a name="features"></a>`features`

Data type: `Any`



Default value: ``undef``

##### <a name="gres"></a>`gres`

Data type: `Any`



Default value: ``undef``

##### <a name="mem_spec_limit"></a>`mem_spec_limit`

Data type: `Any`



Default value: ``undef``

##### <a name="port"></a>`port`

Data type: `Any`



Default value: ``undef``

##### <a name="real_memory"></a>`real_memory`

Data type: `Any`



Default value: ``undef``

##### <a name="reason"></a>`reason`

Data type: `Any`



Default value: ``undef``

##### <a name="sockets"></a>`sockets`

Data type: `Any`



Default value: ``undef``

##### <a name="sockets_per_board"></a>`sockets_per_board`

Data type: `Any`



Default value: ``undef``

##### <a name="state"></a>`state`

Data type: `Slurm::NodeState`



Default value: `'UNKNOWN'`

##### <a name="threads_per_core"></a>`threads_per_core`

Data type: `Any`



Default value: ``undef``

##### <a name="tmp_disk"></a>`tmp_disk`

Data type: `Optional[Integer]`



Default value: ``undef``

##### <a name="tres_weights"></a>`tres_weights`

Data type: `Any`



Default value: ``undef``

##### <a name="weight"></a>`weight`

Data type: `Optional[Integer]`



Default value: ``undef``

##### <a name="order"></a>`order`

Data type: `Any`



Default value: `'90'`

### <a name="slurmnodeset"></a>`slurm::nodeset`

Manage SLURM nodeset configuration

#### Parameters

The following parameters are available in the `slurm::nodeset` defined type:

* [`feature`](#feature)
* [`nodes`](#nodes)
* [`node_set`](#node_set)
* [`order`](#order)

##### <a name="feature"></a>`feature`

Data type: `Optional[String]`



Default value: ``undef``

##### <a name="nodes"></a>`nodes`

Data type: `Optional[String]`



Default value: ``undef``

##### <a name="node_set"></a>`node_set`

Data type: `String`



Default value: `$name`

##### <a name="order"></a>`order`

Data type: `Any`



Default value: `'40'`

### <a name="slurmpartition"></a>`slurm::partition`

Manage a SLURM partition configuration

#### Parameters

The following parameters are available in the `slurm::partition` defined type:

* [`partition_name`](#partition_name)
* [`alloc_nodes`](#alloc_nodes)
* [`allow_accounts`](#allow_accounts)
* [`allow_groups`](#allow_groups)
* [`allow_qos`](#allow_qos)
* [`alternate`](#alternate)
* [`cpu_bind`](#cpu_bind)
* [`default`](#default)
* [`def_cpu_per_gpu`](#def_cpu_per_gpu)
* [`def_mem_per_cpu`](#def_mem_per_cpu)
* [`def_mem_per_gpu`](#def_mem_per_gpu)
* [`def_mem_per_node`](#def_mem_per_node)
* [`deny_accounts`](#deny_accounts)
* [`deny_qos`](#deny_qos)
* [`default_time`](#default_time)
* [`disable_root_jobs`](#disable_root_jobs)
* [`exclusive_user`](#exclusive_user)
* [`grace_time`](#grace_time)
* [`hidden`](#hidden)
* [`lln`](#lln)
* [`max_cpus_per_node`](#max_cpus_per_node)
* [`max_mem_per_cpu`](#max_mem_per_cpu)
* [`max_mem_per_node`](#max_mem_per_node)
* [`max_nodes`](#max_nodes)
* [`max_time`](#max_time)
* [`min_nodes`](#min_nodes)
* [`nodes`](#nodes)
* [`over_subscribe`](#over_subscribe)
* [`over_time_limit`](#over_time_limit)
* [`preempt_mode`](#preempt_mode)
* [`priority_job_factor`](#priority_job_factor)
* [`priority_tier`](#priority_tier)
* [`qos`](#qos)
* [`req_resv`](#req_resv)
* [`resume_timeout`](#resume_timeout)
* [`root_only`](#root_only)
* [`select_type_parameters`](#select_type_parameters)
* [`shared`](#shared)
* [`state`](#state)
* [`suspend_time`](#suspend_time)
* [`suspend_timeout`](#suspend_timeout)
* [`tres_billing_weights`](#tres_billing_weights)
* [`order`](#order)

##### <a name="partition_name"></a>`partition_name`

Data type: `Any`



Default value: `$name`

##### <a name="alloc_nodes"></a>`alloc_nodes`

Data type: `Any`



Default value: ``undef``

##### <a name="allow_accounts"></a>`allow_accounts`

Data type: `Any`



Default value: ``undef``

##### <a name="allow_groups"></a>`allow_groups`

Data type: `Any`



Default value: ``undef``

##### <a name="allow_qos"></a>`allow_qos`

Data type: `Any`



Default value: ``undef``

##### <a name="alternate"></a>`alternate`

Data type: `Any`



Default value: ``undef``

##### <a name="cpu_bind"></a>`cpu_bind`

Data type: `Any`



Default value: ``undef``

##### <a name="default"></a>`default`

Data type: `Optional[Enum['YES','NO']]`



Default value: ``undef``

##### <a name="def_cpu_per_gpu"></a>`def_cpu_per_gpu`

Data type: `Any`



Default value: ``undef``

##### <a name="def_mem_per_cpu"></a>`def_mem_per_cpu`

Data type: `Any`



Default value: ``undef``

##### <a name="def_mem_per_gpu"></a>`def_mem_per_gpu`

Data type: `Any`



Default value: ``undef``

##### <a name="def_mem_per_node"></a>`def_mem_per_node`

Data type: `Any`



Default value: ``undef``

##### <a name="deny_accounts"></a>`deny_accounts`

Data type: `Any`



Default value: ``undef``

##### <a name="deny_qos"></a>`deny_qos`

Data type: `Any`



Default value: ``undef``

##### <a name="default_time"></a>`default_time`

Data type: `Any`



Default value: ``undef``

##### <a name="disable_root_jobs"></a>`disable_root_jobs`

Data type: `Optional[Enum['YES','NO']]`



Default value: ``undef``

##### <a name="exclusive_user"></a>`exclusive_user`

Data type: `Optional[Enum['YES','NO']]`



Default value: ``undef``

##### <a name="grace_time"></a>`grace_time`

Data type: `Any`



Default value: ``undef``

##### <a name="hidden"></a>`hidden`

Data type: `Optional[Enum['YES','NO']]`



Default value: ``undef``

##### <a name="lln"></a>`lln`

Data type: `Optional[Enum['YES','NO']]`



Default value: ``undef``

##### <a name="max_cpus_per_node"></a>`max_cpus_per_node`

Data type: `Any`



Default value: ``undef``

##### <a name="max_mem_per_cpu"></a>`max_mem_per_cpu`

Data type: `Any`



Default value: ``undef``

##### <a name="max_mem_per_node"></a>`max_mem_per_node`

Data type: `Any`



Default value: ``undef``

##### <a name="max_nodes"></a>`max_nodes`

Data type: `Any`



Default value: ``undef``

##### <a name="max_time"></a>`max_time`

Data type: `Any`



Default value: ``undef``

##### <a name="min_nodes"></a>`min_nodes`

Data type: `Any`



Default value: ``undef``

##### <a name="nodes"></a>`nodes`

Data type: `Any`



Default value: ``undef``

##### <a name="over_subscribe"></a>`over_subscribe`

Data type: `Optional[Enum['EXCLUSIVE','FORCE','YES','NO']]`



Default value: ``undef``

##### <a name="over_time_limit"></a>`over_time_limit`

Data type: `Any`



Default value: ``undef``

##### <a name="preempt_mode"></a>`preempt_mode`

Data type: `Optional[Slurm::PreemptMode]`



Default value: ``undef``

##### <a name="priority_job_factor"></a>`priority_job_factor`

Data type: `Any`



Default value: ``undef``

##### <a name="priority_tier"></a>`priority_tier`

Data type: `Any`



Default value: ``undef``

##### <a name="qos"></a>`qos`

Data type: `Any`



Default value: ``undef``

##### <a name="req_resv"></a>`req_resv`

Data type: `Any`



Default value: ``undef``

##### <a name="resume_timeout"></a>`resume_timeout`

Data type: `Any`



Default value: ``undef``

##### <a name="root_only"></a>`root_only`

Data type: `Optional[Enum['YES','NO']]`



Default value: ``undef``

##### <a name="select_type_parameters"></a>`select_type_parameters`

Data type: `Optional[Slurm::SelectTypeParameters]`



Default value: ``undef``

##### <a name="shared"></a>`shared`

Data type: `Any`



Default value: ``undef``

##### <a name="state"></a>`state`

Data type: `Slurm::PartitionState`



Default value: `'UP'`

##### <a name="suspend_time"></a>`suspend_time`

Data type: `Any`



Default value: ``undef``

##### <a name="suspend_timeout"></a>`suspend_timeout`

Data type: `Any`



Default value: ``undef``

##### <a name="tres_billing_weights"></a>`tres_billing_weights`

Data type: `Any`



Default value: ``undef``

##### <a name="order"></a>`order`

Data type: `Any`



Default value: `'50'`

### <a name="slurmspank"></a>`slurm::spank`

Manage SLURM SPANK plugin

#### Parameters

The following parameters are available in the `slurm::spank` defined type:

* [`ensure`](#ensure)
* [`plugin`](#plugin)
* [`arguments`](#arguments)
* [`required`](#required)
* [`manage_package`](#manage_package)
* [`package_name`](#package_name)
* [`package_ensure`](#package_ensure)
* [`order`](#order)

##### <a name="ensure"></a>`ensure`

Data type: `Enum['present','absent']`

Ensure state of SPANK plugin

Default value: `'present'`

##### <a name="plugin"></a>`plugin`

Data type: `String`

The shared library

Default value: `"${name}.so"`

##### <a name="arguments"></a>`arguments`

Data type: `Optional[Variant[Hash, Array, String]]`

Arguments for the plugin

Default value: ``undef``

##### <a name="required"></a>`required`

Data type: `Boolean`

Is this plugin required?

Default value: ``false``

##### <a name="manage_package"></a>`manage_package`

Data type: `Boolean`

Manage plugin package?

Default value: ``true``

##### <a name="package_name"></a>`package_name`

Data type: `String`

Plugin package name

Default value: `"slurm-spank-${name}"`

##### <a name="package_ensure"></a>`package_ensure`

Data type: `String`

Plugin package ensure value

Default value: `'installed'`

##### <a name="order"></a>`order`

Data type: `Any`

Order in plugstack.conf

Default value: `'50'`

### <a name="slurmswitch"></a>`slurm::switch`

Add switch to topology.conf

#### Examples

##### 

```puppet
slurm::switch { 'switch1':
  switches => 'switch[2-3],
}
slurm::switch { 'switch2':
  nodes => 'c0[1-2]',
}
```

#### Parameters

The following parameters are available in the `slurm::switch` defined type:

* [`switch_name`](#switch_name)
* [`switches`](#switches)
* [`nodes`](#nodes)
* [`link_speed`](#link_speed)
* [`order`](#order)

##### <a name="switch_name"></a>`switch_name`

Data type: `Any`

= $name,
SwitchName value, see man page for topology.conf

Default value: `$name`

##### <a name="switches"></a>`switches`

Data type: `Any`

= undef,
Switches value, see man page for topology.conf

Default value: ``undef``

##### <a name="nodes"></a>`nodes`

Data type: `Any`

= undef,
Nodes value, see man page for topology.conf

Default value: ``undef``

##### <a name="link_speed"></a>`link_speed`

Data type: `Any`

= undef,
LinkSpeed value, see man page for topology.conf

Default value: ``undef``

##### <a name="order"></a>`order`

Data type: `Any`

= '50',
Order inside topology.conf

Default value: `'50'`

## Data types

### <a name="slurmdownnodestate"></a>`Slurm::DownNodeState`

The Slurm::DownNodeState data type.

Alias of

```puppet
Enum['DOWN', 'DRAIN', 'FAIL', 'FAILING', 'UNKNOWN']
```

### <a name="slurmnodestate"></a>`Slurm::NodeState`

The Slurm::NodeState data type.

Alias of

```puppet
Variant[Enum['CLOUD','FUTURE'], Slurm::DownNodeState]
```

### <a name="slurmpartitionstate"></a>`Slurm::PartitionState`

The Slurm::PartitionState data type.

Alias of

```puppet
Enum['UP', 'DOWN', 'DRAIN', 'INACTIVE']
```

### <a name="slurmpreemptmode"></a>`Slurm::PreemptMode`

The Slurm::PreemptMode data type.

Alias of

```puppet
Enum['OFF', 'CANCEL', 'CHECKPOINT', 'GANG', 'REQUEUE', 'SUSPEND']
```

### <a name="slurmselecttypeparameters"></a>`Slurm::SelectTypeParameters`

The Slurm::SelectTypeParameters data type.

Alias of

```puppet
Enum['CR_Core', 'CR_Core_Memory', 'CR_Socket', 'CR_Socket_Memory']
```

## Tasks

### <a name="reconfig"></a>`reconfig`

Execute 'scontrol reconfig'

**Supports noop?** false

#### Parameters

##### `scontrol`

Data type: `String[1]`

Path to scontrol (default: 'scontrol', searches $PATH)

